#include <libpv_config.h>

#include <libpv.h>
#include <pv_lock.h>
#include <pv_bs.h>

void pv_flush(pv_engine_t	*engine_anon,
	      void		*ptr,
	      size_t		len)
{
	struct pv_engine	*engine = (struct pv_engine *)engine_anon;
	struct pv_backing_store	*store = &engine->store;
	off_t			offset = ptr - store->map;
	
	if (store->shmid < 0)
		return;

	if (offset >= store->size)
		return;

	len = MIN(len, store->size - offset);

	pv_bs_flush(engine, ptr, len);
}


void pv_lock(pv_engine_t	*engine_anon)
{
	struct pv_engine *engine = (struct pv_engine *)engine_anon;

	pv_lock_lock(engine);
}


void pv_unlock(pv_engine_t	*engine_anon)
{
	struct pv_engine *engine = (struct pv_engine *)engine_anon;

	pv_lock_unlock(engine);
}
