#include <errno.h>
#include <string.h>

#include <libpv.h>
#include <pv_types.h>
#include <pv_bs.h>

/*
 * this functions flushes!
 */
int pv_default(pv_engine_t *engine_anon, void *pv_var)
{
	struct pv_engine	*engine = (struct pv_engine *)engine_anon;
	struct pv		*pv;
	int			finished = 0;

	if (pv_var == NULL) {
		pv_bs_flush_all(engine);
		return 0;
	}

	for (goto_head(&engine->pv_list); !finished; goto_next(&engine->pv_list)) {
		
		if (is_last(engine->pv_list))
			finished=1;

		pv = (struct pv *)list_get_element_data(engine->pv_list);
		if (pv_var == NULL
		    || (engine->store.map + pv->offset) == pv_var) {
			union pv_data	*data = engine->store.map + pv->offset;

			switch (pv->type) {
			case PV_TYPE_INT8:
				*data->s8 = pv->dflt.s8;
				break;
			case PV_TYPE_UINT8:
				*data->u8 = pv->dflt.u8;
				break;

			case PV_TYPE_INT16:
				*data->s16 = pv->dflt.s16;
				break;
			case PV_TYPE_UINT16:
				*data->u16 = pv->dflt.u16;
				break;

			case PV_TYPE_INT32:
				*data->s32 = pv->dflt.s32;
				break;
			case PV_TYPE_UINT32:
				*data->u32 = pv->dflt.u32;
				break;

			case PV_TYPE_INT64:
				*data->s64 = pv->dflt.s64;
				break;
			case PV_TYPE_UINT64:
				*data->u64 = pv->dflt.u64;
				break;

			case PV_TYPE_STRING:
				memcpy(data->string, pv->dflt.string, pv->size);
				break;

			case PV_TYPE_UNDEF:
				break;
			}

			if (pv_var != NULL) {
				pv_bs_flush(engine, pv_var, pv->size);
				return 0;
			}
		}
	}

	return -EINVAL;
}
